import type { FullCombinator, FullField, FullOperator, FullOptionRecord, OptionGroup, QueryBuilderProps, RuleGroupTypeAny, TranslationsFull } from "../types/index.mjs";
export interface UseFields<F extends FullField> {
	defaultField: FullField;
	fields: F[] | OptionGroup<F>[];
	fieldMap: Partial<FullOptionRecord<FullField>>;
}
export declare const useFields: <F extends FullField>(props: {
	translations: TranslationsFull;
} & Pick<QueryBuilderProps<RuleGroupTypeAny, F, FullOperator, FullCombinator>, "fields" | "baseField" | "autoSelectField">) => UseFields<F>;
