/**
* Logs a warning if drag-and-drop is enabled but the required dependencies
* (`react-dnd` and either `react-dnd-html5-backend` or `react-dnd-touch-backend`)
* were not detected.
*
* @group Hooks
*/
export declare const useReactDndWarning: (enableDragAndDrop: boolean, dndRefs: boolean) => void;
