import * as React from "react";
import type { FullField, MatchMode, MatchModeEditorProps, RuleType, Schema } from "../types";
/**
* Default `matchModeEditor` component used by {@link QueryBuilder}.
*
* @group Components
*/
export declare const MatchModeEditor: (props: MatchModeEditorProps) => React.JSX.Element | null;
export interface UseMatchModeEditor {
	thresholdNum: number;
	thresholdRule: RuleType;
	thresholdSchema: Schema<FullField, string>;
	handleChangeMode: (mode: MatchMode) => void;
	handleChangeThreshold: (threshold: number) => void;
}
export declare const useMatchModeEditor: (props: MatchModeEditorProps) => UseMatchModeEditor;
