import type { RuleGroupProcessor } from "../../types/index.noReact";
/**
* Default fallback object used by {@link formatQuery} for "mongodb_query" format.
*
* @group Export
*/
export declare const mongoDbFallback: {
	readonly $and: readonly [{
		readonly $expr: true;
	}];
};
/**
* Rule group processor used by {@link formatQuery} for "mongodb_query" format.
*
* @group Export
*/
export declare const defaultRuleGroupProcessorMongoDBQuery: RuleGroupProcessor;
