import type { RuleProcessor } from "../../types/index.noReact";
/**
* Default operator processor used by {@link formatQuery} for "sql" and "parameterized*" formats.
*
* @group Export
*/
export declare const defaultOperatorProcessorSQL: RuleProcessor;
/**
* Default rule processor used by {@link formatQuery} for "sql" format.
*
* @group Export
*/
export declare const defaultRuleProcessorSQL: RuleProcessor;
