import type { JsonLogicAll, JsonLogicAnd, JsonLogicDoubleNegation, JsonLogicEqual, JsonLogicGreaterThan, JsonLogicGreaterThanOrEqual, JsonLogicInArray, JsonLogicInString, JsonLogicLessThan, JsonLogicLessThanOrEqual, JsonLogicNegation, JsonLogicNone, JsonLogicNotEqual, JsonLogicOr, JsonLogicSome, JsonLogicStrictEqual, JsonLogicStrictNotEqual, JsonLogicVar, RQBJsonLogicEndsWith, RQBJsonLogicStartsWith, RQBJsonLogicVar } from "../../types/index.noReact";
import type { JsonLogicBetweenExclusive, JsonLogicBetweenInclusive } from "./types";
export declare const isJsonLogicVar: (logic: unknown) => logic is JsonLogicVar<RQBJsonLogicStartsWith | RQBJsonLogicEndsWith>;
export declare const isRQBJsonLogicVar: (logic: unknown) => logic is RQBJsonLogicVar;
export declare const isJsonLogicEqual: (logic: unknown) => logic is JsonLogicEqual;
export declare const isJsonLogicStrictEqual: (logic: unknown) => logic is JsonLogicStrictEqual;
export declare const isJsonLogicNotEqual: (logic: unknown) => logic is JsonLogicNotEqual;
export declare const isJsonLogicStrictNotEqual: (logic: unknown) => logic is JsonLogicStrictNotEqual;
export declare const isJsonLogicNegation: (logic: unknown) => logic is JsonLogicNegation;
export declare const isJsonLogicDoubleNegation: (logic: unknown) => logic is JsonLogicDoubleNegation;
export declare const isJsonLogicOr: (logic: unknown) => logic is JsonLogicOr<RQBJsonLogicStartsWith | RQBJsonLogicEndsWith>;
export declare const isJsonLogicAnd: (logic: unknown) => logic is JsonLogicAnd<RQBJsonLogicStartsWith | RQBJsonLogicEndsWith>;
export declare const isJsonLogicGreaterThan: (logic: unknown) => logic is JsonLogicGreaterThan<RQBJsonLogicStartsWith | RQBJsonLogicEndsWith>;
export declare const isJsonLogicGreaterThanOrEqual: (logic: unknown) => logic is JsonLogicGreaterThanOrEqual<RQBJsonLogicStartsWith | RQBJsonLogicEndsWith>;
export declare const isJsonLogicLessThan: (logic: unknown) => logic is JsonLogicLessThan<RQBJsonLogicStartsWith | RQBJsonLogicEndsWith>;
export declare const isJsonLogicLessThanOrEqual: (logic: unknown) => logic is JsonLogicLessThanOrEqual<RQBJsonLogicStartsWith | RQBJsonLogicEndsWith>;
export declare const isJsonLogicInArray: (logic: unknown) => logic is JsonLogicInArray<RQBJsonLogicStartsWith | RQBJsonLogicEndsWith>;
export declare const isJsonLogicInString: (logic: unknown) => logic is JsonLogicInString<RQBJsonLogicStartsWith | RQBJsonLogicEndsWith>;
export declare const isJsonLogicAll: (logic: unknown) => logic is JsonLogicAll<RQBJsonLogicStartsWith | RQBJsonLogicEndsWith>;
export declare const isJsonLogicNone: (logic: unknown) => logic is JsonLogicNone<RQBJsonLogicStartsWith | RQBJsonLogicEndsWith>;
export declare const isJsonLogicSome: (logic: unknown) => logic is JsonLogicSome<RQBJsonLogicStartsWith | RQBJsonLogicEndsWith>;
export declare const isJsonLogicBetweenExclusive: (logic: unknown) => logic is JsonLogicBetweenExclusive;
export declare const isJsonLogicBetweenInclusive: (logic: unknown) => logic is JsonLogicBetweenInclusive;
export declare const isRQBJsonLogicStartsWith: (logic: unknown) => logic is RQBJsonLogicStartsWith;
export declare const isRQBJsonLogicEndsWith: (logic: unknown) => logic is RQBJsonLogicEndsWith;
