import type { RuleGroupProcessor } from "../../types/index.noReact.mjs";
/**
* Default fallback object used by {@link formatQuery} for "prisma" format.
*
* @group Export
*/
export declare const prismaFallback: {};
/**
* Rule group processor used by {@link formatQuery} for "prisma" format.
*
* @group Export
*/
export declare const defaultRuleGroupProcessorPrisma: RuleGroupProcessor<Record<string, unknown> | undefined>;
