import type { ExportOperatorMap, RuleProcessor } from "../../types/index.noReact.mjs";
/**
* Default operator map used by {@link formatQuery} for "natural_language" format.
*
* @group Export
*/
export declare const defaultExportOperatorMap: ExportOperatorMap;
/**
* Default operator processor used by {@link formatQuery} for "natural_language" format.
*
* @group Export
*/
export declare const defaultOperatorProcessorNL: RuleProcessor;
/**
* Default rule processor used by {@link formatQuery} for "natural_language" format.
*
* @group Export
*/
export declare const defaultRuleProcessorNL: RuleProcessor;
